; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    MemCopyx PROTO :DWORD,:DWORD,:DWORD
    regcopy  PROTO :DWORD,:DWORD,:DWORD

    .data
      item dd 0

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hmem3 :DWORD
    LOCAL hbuff :DWORD

    mov hmem3, alloc(16384)
    mov hbuff, alloc(16384)

    print "REP MOVSD timings",13,10,13,10

    push esi

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,32
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 32 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,64
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 64 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,128
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 128 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,256
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 256 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,512
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 512 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,1024
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1024 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke MemCopyx,hmem3,hbuff,4096
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 4096 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 1000000
  @@:
    invoke MemCopyx,hmem3,hbuff,16384
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 16384 bytes",13,10,13,10

  ; ------------------------------------

    print "reg copy timings",13,10,13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,32
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 32 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,64
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 64 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,128
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 128 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,256
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 256 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,512
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 512 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,1024
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1024 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 10000000
  @@:
    invoke regcopy,hmem3,hbuff,4096
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 4096 bytes",13,10

  ; ------------------------------------

    invoke GetTickCount
    push eax
    mov esi, 1000000
  @@:
    invoke regcopy,hmem3,hbuff,16384
    sub esi, 1
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 16384 bytes",13,10

  ; ------------------------------------

    pop esi

    free hbuff
    free hmem3

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

MemCopyx proc src:DWORD,dst:DWORD,ln:DWORD

    push esi
    push edi

    cld
    mov esi, [esp+4+8]
    mov edi, [esp+8+8]
    mov ecx, [esp+12+8]

    shr ecx, 2
    rep movsd

    mov ecx, [esp+12+8]
    and ecx, 3
    rep movsb

    pop edi
    pop esi

    ret 12

MemCopyx endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

regcopy proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov esi, [esp+4+16]     ; src
    mov edi, [esp+8+16]     ; dst
    mov ecx, [esp+12+16]    ; ln

    shr ecx, 4              ; div by 16
    jz tail

  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov edx, [esi+8]
    mov ebp, [esi+12]
    mov [edi], eax
    mov [edi+4], ebx
    mov [edi+8], edx
    mov [edi+12], ebp
    add esi, 16
    add edi, 16
    sub ecx, 1
    jns @B

  tail:
    mov ecx, [esp+12+16]    ; ln
    and ecx, 4
    jz quit

  @@:
    movzx eax, BYTE PTR [esi]
    mov [edi], al
    add esi, 1
    add edi, 1
    sub ecx, 1
    jnz @B

  quit:
    pop ebp
    pop edi
    pop esi
    pop ebx

    ret 12

regcopy endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 







end start
